/*!\file GetSolutionFromInputsx
 * \brief: update datasets using  parameter inputs
 */

#include "./GetSolutionFromInputsx.h"
#include "../../shared/shared.h"
#include "../../include/include.h"
#include "../../toolkits/toolkits.h"
#include "../../EnumDefinitions/EnumDefinitions.h"

void	GetSolutionFromInputsx( Vec* psolution, DataSet* elements,DataSet* nodes, DataSet* vertices,DataSet* loads, DataSet* materials,  Parameters* parameters, int analysis_type, int sub_analysis_type){

	/*intermediary: */
	int gsize;
	int i;
	Element* element=NULL;

	/*output: */
	Vec solution=NULL;

	/*First, get elements and loads configured: */
	elements->Configure(elements,loads, nodes,vertices, materials,parameters);
	loads->Configure(elements, loads, nodes,vertices, materials,parameters);
	nodes->Configure(elements, loads, nodes,vertices, materials,parameters);
	parameters->Configure(elements,loads, nodes,vertices, materials,parameters);

	/*Get size of vector: */
	gsize=nodes->NumberOfDofs();
	
	/*Initialize solution: */
	solution=NewVec(gsize);
	
	/*Go through elements and plug solution: */
	for (i=0;i<elements->Size();i++){
		element=(Element*)elements->GetObjectByOffset(i);
		element->GetSolutionFromInputs(solution,analysis_type,sub_analysis_type);
	}

	/*Assemble vector: */
	VecAssemblyBegin(solution);
	VecAssemblyEnd(solution);

	/*Assign output pointers:*/
	*psolution=solution;

}
